https://www.kaggle.com/code/dhananjay3/image-segmentation-from-scratch-in-pytorch/notebook


# Image Segmentation From scratch using Pytorch[](https://www.kaggleusercontent.com/kf/21928207/eyJhbGciOiJkaXIiLCJlbmMiOiJBMTI4Q0JDLUhTMjU2In0..rtZvhWa6wX4osbG5eIk2bQ.T3tR289Xif-gAMdcVHxe9Zq4bIWMX7zJYWNy5523a6PE69JA4ZmO-S3yswKsP4EE9iyovqYIpeJeyIoyG7kaqo_M10X8INRzdFDsjCW4INU_o-1EJzIiWRbCuaomASLazduGq1PXyLTU9WPf4uD5GJvRa7NaBg-J1MgaTjvd0j-Qalgiz2Xw6GSXYcItJmglZ_GjdipE78FzLKa11ehm9M_SzfztjeNELVDMGkC6yaLJThHYSm-Xc3FhsxEQS9K5aXAs0HpYYo09I5Clf0nuQYRkQ6tubSdMYqi_CMstJFSQI3ltByJ0x3hc4RUeT8jhYAOZOmZVUpbHwEWuaSgm4ld7Qe4Pdy7d0wMUkhIhliTCbZ35pJFQqo-O6-Jezkb3cr6CdG0_muYKtCbeYlambu_TFcVuW1uwN1Ij6ljQw3NQAg5Nq6_diGqW-emesSuceaYZSriSgOKx77LvjX4Dgr4yDnpvlPOjbo0ZcRuWlJuVVy3q7AQfGvZNJcvtRsOHQhjPI1YhbZru0g2TqqWHUUqTHzQ_5BqcPY0i6DfAfCMqLIX-Em6y-pO-SS7uOEMIcFZxfWf-tAZDqtOKgLFBIxZ1KWkSGBeIV4WWVb2PtksKJdC2OOLcwv_rPni73MxCogZE3HJRDlx7hbSzbS-6D5D9dp3a6i7noBDNpJjL_0Y.hMKWkq5bKBlHFjRnpfJ8fg/__resultx__.html?sharingControls=true#Image-Segmentation-From-scratch-using-Pytorch)

This is my first hands on with image segmentation and I tried to learn from existing pytorch notebooks. One thing I imediately noticed is Using High level frameworks like catalyst is very convinient but For learner like me who came here to learn it is difficult to know what is happening under the hood and that's what we are here for,that is what we want to learn. so I wrote this kernel.

### It does all things from scartch so we can see what's happening[](https://www.kaggleusercontent.com/kf/21928207/eyJhbGciOiJkaXIiLCJlbmMiOiJBMTI4Q0JDLUhTMjU2In0..rtZvhWa6wX4osbG5eIk2bQ.T3tR289Xif-gAMdcVHxe9Zq4bIWMX7zJYWNy5523a6PE69JA4ZmO-S3yswKsP4EE9iyovqYIpeJeyIoyG7kaqo_M10X8INRzdFDsjCW4INU_o-1EJzIiWRbCuaomASLazduGq1PXyLTU9WPf4uD5GJvRa7NaBg-J1MgaTjvd0j-Qalgiz2Xw6GSXYcItJmglZ_GjdipE78FzLKa11ehm9M_SzfztjeNELVDMGkC6yaLJThHYSm-Xc3FhsxEQS9K5aXAs0HpYYo09I5Clf0nuQYRkQ6tubSdMYqi_CMstJFSQI3ltByJ0x3hc4RUeT8jhYAOZOmZVUpbHwEWuaSgm4ld7Qe4Pdy7d0wMUkhIhliTCbZ35pJFQqo-O6-Jezkb3cr6CdG0_muYKtCbeYlambu_TFcVuW1uwN1Ij6ljQw3NQAg5Nq6_diGqW-emesSuceaYZSriSgOKx77LvjX4Dgr4yDnpvlPOjbo0ZcRuWlJuVVy3q7AQfGvZNJcvtRsOHQhjPI1YhbZru0g2TqqWHUUqTHzQ_5BqcPY0i6DfAfCMqLIX-Em6y-pO-SS7uOEMIcFZxfWf-tAZDqtOKgLFBIxZ1KWkSGBeIV4WWVb2PtksKJdC2OOLcwv_rPni73MxCogZE3HJRDlx7hbSzbS-6D5D9dp3a6i7noBDNpJjL_0Y.hMKWkq5bKBlHFjRnpfJ8fg/__resultx__.html?sharingControls=true#It-does-all-things-from-scartch-so-we-can-see-what's-happening)

linkcode

## Features of this kernel[](https://www.kaggleusercontent.com/kf/21928207/eyJhbGciOiJkaXIiLCJlbmMiOiJBMTI4Q0JDLUhTMjU2In0..rtZvhWa6wX4osbG5eIk2bQ.T3tR289Xif-gAMdcVHxe9Zq4bIWMX7zJYWNy5523a6PE69JA4ZmO-S3yswKsP4EE9iyovqYIpeJeyIoyG7kaqo_M10X8INRzdFDsjCW4INU_o-1EJzIiWRbCuaomASLazduGq1PXyLTU9WPf4uD5GJvRa7NaBg-J1MgaTjvd0j-Qalgiz2Xw6GSXYcItJmglZ_GjdipE78FzLKa11ehm9M_SzfztjeNELVDMGkC6yaLJThHYSm-Xc3FhsxEQS9K5aXAs0HpYYo09I5Clf0nuQYRkQ6tubSdMYqi_CMstJFSQI3ltByJ0x3hc4RUeT8jhYAOZOmZVUpbHwEWuaSgm4ld7Qe4Pdy7d0wMUkhIhliTCbZ35pJFQqo-O6-Jezkb3cr6CdG0_muYKtCbeYlambu_TFcVuW1uwN1Ij6ljQw3NQAg5Nq6_diGqW-emesSuceaYZSriSgOKx77LvjX4Dgr4yDnpvlPOjbo0ZcRuWlJuVVy3q7AQfGvZNJcvtRsOHQhjPI1YhbZru0g2TqqWHUUqTHzQ_5BqcPY0i6DfAfCMqLIX-Em6y-pO-SS7uOEMIcFZxfWf-tAZDqtOKgLFBIxZ1KWkSGBeIV4WWVb2PtksKJdC2OOLcwv_rPni73MxCogZE3HJRDlx7hbSzbS-6D5D9dp3a6i7noBDNpJjL_0Y.hMKWkq5bKBlHFjRnpfJ8fg/__resultx__.html?sharingControls=true#Features-of-this-kernel)

- Using vanila Unet Architecture
- Deterministic behaviour for reproducability
- K-fold cross validation is already Implemented (i.e. data spliting is done)
- loss function is also implmented for clearity
- Training loop is open to see exactly what is happening
- Processing output by removing mask that occur on black part of input image
- Drawing convex hull before optimizing thresholds ...

